// FTPDemoView.cpp : implementation of the CFTPDemoView class
//

#include "stdafx.h"
#include "FTPDemo.h"

#include "FTPDemoDoc.h"
#include "FTPDemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFTPDemoView

IMPLEMENT_DYNCREATE(CFTPDemoView, CFormView)

BEGIN_MESSAGE_MAP(CFTPDemoView, CFormView)
	//{{AFX_MSG_MAP(CFTPDemoView)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_GET, OnGet)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFTPDemoView construction/destruction

CFTPDemoView::CFTPDemoView()
	: CFormView(CFTPDemoView::IDD)
{
	//{{AFX_DATA_INIT(CFTPDemoView)
	m_URL = _T("");
	m_Login = _T("");
	m_Password = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_FTPConnection = 0;
	m_Login = _T("anonymous");
	m_Password = _T("mail@mail.com");
}

CFTPDemoView::~CFTPDemoView()
{
}

void CFTPDemoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTPDemoView)
	DDX_Control(pDX, IDC_CLIENTLIST, m_ClientList);
	DDX_Control(pDX, IDC_SRVRLIST, m_SrvrList);
	DDX_Text(pDX, IDC_URL, m_URL);
	DDX_Text(pDX, IDC_EDIT1, m_Login);
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	//}}AFX_DATA_MAP
}

BOOL CFTPDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CFTPDemoView::SetupList(CListCtrl &List)
{

	if( List.GetHeaderCtrl()->GetItemCount() == 0 )
	{
		RECT Rect;
		List.DeleteColumn(0);
		List.GetClientRect( &Rect );
		List.InsertColumn(0, "Name" );
		List.InsertColumn(1, "Size" );
		List.SetColumnWidth(0, Rect.right/4*3 );
		List.SetColumnWidth(1, Rect.right/4 );
	}
}

void CFTPDemoView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	SetControls();
	
	SetupList( m_SrvrList );
	SetupList( m_ClientList );

}

/////////////////////////////////////////////////////////////////////////////
// CFTPDemoView printing

BOOL CFTPDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CFTPDemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CFTPDemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CFTPDemoView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CFTPDemoView diagnostics

#ifdef _DEBUG
void CFTPDemoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CFTPDemoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CFTPDemoDoc* CFTPDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFTPDemoDoc)));
	return (CFTPDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFTPDemoView message handlers

void CFTPDemoView::OnConnect() 
{
	UpdateData();

	if( !m_FTPConnection )
	{
		try
		{
			m_FTPConnection = m_InternetSession.GetFtpConnection( m_URL, m_Login, m_Password );
		}
		catch(...)
		{	/* Error reported below */ }
		
		if( !m_FTPConnection )
			MessageBox( "Error establishing FTP connection" );
		else
		{	// Connection established
			GetDlgItem( IDC_CONNECT )->SetWindowText( "Disconnect" );
			if( m_LocalDir.IsEmpty() )
			{
				char Buffer[_MAX_PATH];
				GetCurrentDirectory( sizeof(Buffer), Buffer );
				m_LocalDir = Buffer;
			}
			BuildClientFileList();
			BuildSrvrFileList();
		}
	}
	else
	{
		GetDlgItem( IDC_CONNECT )->SetWindowText( "Connect" );
		m_FTPConnection->Close();
		m_FTPConnection = 0;
	}
	SetControls();
}

void CFTPDemoView::SetControls()
{
	CWnd* pWnd = GetDlgItem( IDC_SRVRLIST );
	pWnd->EnableWindow( m_FTPConnection!=0 );

	pWnd = GetDlgItem( IDC_CLIENTLIST );
	pWnd->EnableWindow( m_FTPConnection!=0 );
	pWnd = GetDlgItem( IDC_SEND );
	pWnd->EnableWindow( m_FTPConnection!=0 );
	pWnd = GetDlgItem( IDC_GET );
	pWnd->EnableWindow( m_FTPConnection!=0 );
	pWnd = GetDlgItem( IDC_URL );
	pWnd->EnableWindow( m_FTPConnection==0 );
}

void CFTPDemoView::BuildSrvrFileList()
{
	CFtpFileFind Files( m_FTPConnection );
	BuildFileList( Files, m_SrvrList );
}


void CFTPDemoView::BuildClientFileList()
{
	CFileFind Files;
	BuildFileList( Files, m_ClientList );
}

void CFTPDemoView::BuildFileList(CFileFind &Files, CListCtrl& List )
{
	int i, Count=0;
	BOOL bFound, NeedParent = TRUE;
	CString Str;
	List.DeleteAllItems();
	bFound=Files.FindFile( );
	while( bFound )
	{
		bFound =  Files.FindNextFile();
		Str = Files.GetFileName();
		if( Str!= "." )
		{
			i = List.InsertItem(Count++, Str, 0 );
			if( Files.IsDirectory() )
			{
				Str = "Dir";
				if( Str==".." )
					NeedParent = FALSE;
			}
			else
				Str.Format( "%d", Files.GetLength() );
			List.SetItem( i, 1, LVIF_TEXT, Str, 0, 0, 0, 0 );
		}
	}
	if( NeedParent )
	{
		i = List.InsertItem(0, "..", 0 );
		List.SetItem( i, 1, LVIF_TEXT, "Dir", 0, 0, 0, 0 );
	}
}


void CFTPDemoView::OnGet() 
{
	int i = m_SrvrList.GetNextItem( -1, LVNI_SELECTED );
	if( i >= 0 )
	{
		char Name[_MAX_PATH];
		m_SrvrList.GetItemText( i, 0, Name, sizeof(Name) );
		m_FTPConnection->GetFile( Name, Name );
		BuildClientFileList();
	}
}

void CFTPDemoView::OnSend() 
{
	int i = m_ClientList.GetNextItem( -1, LVNI_SELECTED );
	if( i >= 0 )
	{
		char LocalName[_MAX_PATH], RemoteName[_MAX_PATH];
		m_ClientList.GetItemText( i, 0, RemoteName, sizeof(RemoteName) );
		sprintf( LocalName, "%s\\%s", (LPCSTR)m_LocalDir, RemoteName );
		if( m_FTPConnection->PutFile( LocalName, RemoteName ) )
			BuildSrvrFileList();
		else
			MessageBox( "Unable to send file (upload security?)" );
	}
	
}
